; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


; Lost Labyrinth
; Hauptprogramm
; Version: 0.9.2
; (c) 2003 - 2004  Markus Dbele (mar_doe@gmx.de)    (Umgebung: Linux)
;                  Frank Malota  (malota@web.de)     (Umgebung: Windows)
; erstellt:        25.03.2003 Frank Malota  (malota@web.de)
; letzte nderung: 28.03.2003 Frank Malota  (malota@web.de)
;                  02.04.2003 Markus Dbele (mar_doe@gmx.de) Linuxversion (ca. 2 h)
;                  17.01.2004 Markus Dbele (mar_doe@gmx.de) Skills auswhlen begonnen (ca. 12 h!)
;                  19.01.2004 Markus Dbele (mar_doe@gmx.de) Skills Men erweitert     (ca. 8 h)
;                  20.01.2004 Markus Dbele (mar_doe@gmx.de) Skills Men fertig + Titelscreen (ca. 8 h)
;                  21.01.2004 Markus Dbele (mar_doe@gmx.de) Sound hinzugefgt (ca. 1 h)
;                  23.01.2004 Markus Dbele (mar_doe@gmx.de) Hauptschirm erweitert, Highscores, Credits (ca. 10 h)
;                  24.01.2004 Markus Dbele (mar_doe@gmx.de) Aufsteigen und Hilfescreen (ca. 8 h)
;                  25.01.2004 Markus Dbele (mar_doe@gmx.de) Inventar angefangen (ca. 1 h)
;                  27.01.2004 Markus Dbele (mar_doe@gmx.de) Inventar erweitert (ca. 4 h)
;                  28.01.2004 Markus Dbele (mar_doe@gmx.de) Spellmenue angefangen, plus Animationen (ca. 4 h)
;                  29.01.2004 Markus Dbele (mar_doe@gmx.de) Inventar erweitert, Laby generieren (ca. 8 h)
;                  30.01.2004 Markus Dbele (mar_doe@gmx.de) Monster/Skelette/Fallen etc setzen, Kampf (ca. 4 h)
;                  31.01.2004 Markus Dbele (mar_doe@gmx.de) Kampf erweitert (ca. 6 h)
;                  01.02.2004 Markus Dbele (mar_doe@gmx.de) Highscore (ca. 4 h)
;                  02.02.2004 Markus Dbele (mar_doe@gmx.de) Verhungern, Verdursten, Fallen (ca. 4 h)
;                  03.02.2004 Markus Dbele (mar_doe@gmx.de) Skills, Nexus, Zauber (ca. 7 h)
;                  04.02.2004 Markus Dbele (mar_doe@gmx.de) Zaubern erweitert, L.O.S. (ca. 3 h)
;                  05.02.2004 Markus Dbele (mar_doe@gmx.de) Zaubern erweitert, Wirbelwind (ca. 3 h)
;                  06.02.2004 Markus Dbele (mar_doe@gmx.de) 11 Rume (ca. 11 h)
;                  07.02.2004 Markus Dbele (mar_doe@gmx.de) Wiedergnger, Critical Hits, Fallen (ca. 4h)
;                  08.02.2004 Markus Dbele (mar_doe@gmx.de) 12 Zauber, Optionen, Hinterhalte (ca. 5 h)
;                  09.02.2004 Markus Dbele (mar_doe@gmx.de) Alle Monster, Lichtdauer, 2 Zauber (Ca. 5 h)
;                  10.02.2004 Markus Dbele (mar_doe@gmx.de) Waffen, Ruestungen (ca. 3 h)
;                  11.02.2004 Markus Dbele (mar_doe@gmx.de) Druiden-, Schwarze-, Feuer- und Erdmagie (ca. 4 h)
;                  12.02.2004 Markus Dbele (mar_doe@gmx.de) Wasser-, Sternen, Bardenmagie (ca. 4 h)
;                  13.02.2004 Markus Dbele (mar_doe@gmx.de) Luftmagie (ca. 1 h)
;                  14.02.2004 Markus Dbele (mar_doe@gmx.de) Fehler behoben (ca. 1 h)
;                  15.02.2004 Markus Dbele (mar_doe@gmx.de) Monster Fernkampf (ca. 2 h)
;                  16.02.2004 Markus Dbele (mar_doe@gmx.de) Fernkampf erweitert (ca. 3 h)
;                  17.02.2004 Markus Dbele (mar_doe@gmx.de) Flueche (ca. 4 h)
;                  18.02.2004 Markus Dbele (mar_doe@gmx.de) Runenfallen (ca. 2 h)
;                  19.02.2004 Markus Dbele (mar_doe@gmx.de) Windows Version (ca. 4 h)
;                  20.02.2004 Markus Dbele (mar_doe@gmx.de) Windows Version (ca. 1 h)
;                  22.02.2004 Markus Dbele (mar_doe@gmx.de) Maennchen auswaehlen, Illusionsmagie (ca. 2 h)
;                  23.02.2004 Markus Dbele (mar_doe@gmx.de) Characterinfo, Hohe Magie, Fluss, Brunnen, Teleport (ca. 4 h)
;                  24.02.2004 Markus Dbele (mar_doe@gmx.de) Hexerei, Schleichen, Bogenschiessen, Warlock (ca. 3 h)
;                  25.02.2004 Markus Dbele (mar_doe@gmx.de) 9 neue Zauber, aktive Zauber neu (ca. 5 h)
;                  26.02.2004 Markus Dbele (mar_doe@gmx.de) 3 neue Zauber (ca. 1 h)
;                  28.02.2004 Markus Dbele (mar_doe@gmx.de) 8 neue Zauber (ca. 3 h)
;                  29.02.2004 Markus Dbele (mar_doe@gmx.de) 5 neue zauber, Schriftrollen (ca. 3 h)
;                  01.03.2004 Markus Dbele (mar_doe@gmx.de) Traenke, Code cleanup (ca. 5 h)
;                  02.03.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing (ca. 2 h)
;                  03.03.2004 Markus Dbele (mar_doe@gmx.de) Verborgene Schaetze, Altar, 5 mag. Gegenstaende (ca. 5 h)
;                  06.03.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing, Zauberstaebe, Medusahaupt (ca. 3 h)
;                  07.03.2004 Markus Dbele (mar_doe@gmx.de) Monstereigenschaften (ca. 1 h)
;                  08.03.2004 Markus Dbele (mar_doe@gmx.de) Laufen mit Maus (ca. 1 h)
;                  09.03.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing, Windows Version (ca. 4 h)
;                  10.03.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing, Ablegen (ca. 1 h)
;                  11.03.2004 Markus Dbele (mar_doe@gmx.de) Maussteuerung, Feuerdaemon, Verstaerkung (ca. 5 h)
;                  12.03.2004 Markus Dbele (mar_doe@gmx.de) Zweihaender (ca. 1 h)
;                  14.03.2004 Markus Dbele (mar_doe@gmx.de) Behinderung durch Ruestung (ca. 1 h)
;                  16.03.2004 Markus Dbele (mar_doe@gmx.de) Geheimtueren entdecken, Diebstahl, Skills, Pilze (ca. 6 h)
;                  23.03.2004 Markus Dbele (mar_doe@gmx.de) Bugfixes (ca. 1 h)
;                  24.03.2004 Markus Dbele (mar_doe@gmx.de) Buttonfunktionen anzeigen (ca. 2 h)
;                  25.03.2004 Markus Dbele (mar_doe@gmx.de) Buttonfunktionen fertig (ca. 1 h)
;                  04.04.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing (ca. 1 h)
;                  14.04.2004 Markus Dbele (mar_doe@gmx.de) Bugfixing, Optionen mit Maus (ca. 1 h)
;                  15.04.2004 Markus Dbele (mar_doe@gmx.de) Multiplayer (ca. 3 h)
;                  27.04.2004 Markus Dbele (mar_doe@gmx.de) Multiplayer (ca. 1 h)
;                  28.04.2004 Markus Dbele (mar_doe@gmx.de) Multiplayer (ca. 1 h)
;                  15.05.2004 Markus Dbele (mar_doe@gmx.de) Multiplayer (ca. 3 h)

; Todo Liste:

; Nchste Version
; - mehr magische Gegenstaende
; - Sonderlevel
; - Beschwrungszauber
; - Zauber auf Tasten legen
; - bei zaubern mit buchstaben scrollen
; - Joystick
; - Hexe
; - Wassermonster
; - Fehlermeldung bei fehlenden Dateien
; - Save Character Skills
; - Mehr Sprachen -> Sprachenfile. Spanisch!
; - Von ausgang laufen kostet einen Zug?
; - Spieler auf Karte anzeigen
; - Okay Box bei neuem Level


; - spell 60 ist leer! -> aufladen


; Konstanten laden
IncludeFile "constants_laby.pb"     ; Konstanten:  Labyrinth
IncludeFile "constants_sprites.pb"  ; Konstanten:  Sprites
IncludeFile "constants_images.pb"   ; Konstanten:  Bilder
IncludeFile "konstanten.pb"         ; Konstanten
IncludeFile "constants_sounds.pb"   ; Konstanten:  Gerusche
IncludeFile "help.pb"               ; Konstanten:  Hilfetexte zu Skills


; Strukturen einbinden
IncludeFile "strukturen.pb" ; Strukturen fr Character, Skills, Locked Skills

; Das Labyrinth
Structure laby
   feld.w
   lebenspunkte.w
   objekt.w
EndStructure

Dim labyrinth.laby(#MAX_LABY_SIZE,#MAX_LABY_SIZE)



;Allgemeine Variablen
akt_spieler.b = 1
test.b = 0     ; Testlauf ? (0=nein 1=ja)
Dim haendler_objekte.w (40)
frame.b = 0        ; Animationsframe des Charakters
framestep.b = 0    ; Verzgerung der Animation des Charakters
xx_old = 1
yy_old = 1
xmod.b = 0         ; Richtungsnderung des Charakters in X-Richtung
ymod.b = 0         ; Richtungsnderung des Charakters in Y-Richtung
messages.s = ""    ; Nachrichten des Messagefensters
level.w = 1        ; die aktuelle Labyrinth-Ebene
sprache.b = 0      ; 0 ist Deutsch, 1 ist Englisch
mmouse_x.w
mmouse_y.w
mmouse_links.w
mmouse_rechts.w
zw_bild.b = 0      ; Splash Bilder
dim spieler.character(#ANZ_SPIELER)
benutzen.b         ; Fr Inventarmenue
pos.b              ; Fr laby_gen
ganglaenge.w       ; Fr laby_gen
sprite_x.w
sprite_y.w
spell_x.w
spell_y.w
blocked.w
room.w
nr.w
angreifen.w = 1
nach_kampf.b = 0
punkte.w = 0
nachricht_text.s
feld.b
raumx.w
raumy.w
bewegt.b = 0
anz_spieler.b = 1

zeit.s
altezeit.s
mauszauber.b
mauszauber2.b
letzter_eintrag.b = 0
Dim xsprites(20)
Dim ysprites(20)
Dim fsprites(20)
Dim rsprites(20)

Dim zauberliste.s(150)
anz_zauber.b = 0

Dim optionenliste.s(130)
akt_option.b = 1

; -------------------------------------------------------------------------

Declare habich(nr.w)
Declare monsterkunde()
Declare draw_screen(x_offset.b, y_offset.b)
Declare draw_character(face.b, frame.b)
Declare feld_waehlen()
Declare laby_rahmen()
Declare show_logo()
Declare show_varys()
Declare show_buttons()
Declare gen_laby()
Declare tot()
Declare draw_tile(nr.w, x.w, y.w, offset_x.b, offset_y.b)
Declare cast_it()
Declare trinken(welchen.w)
Declare eintragen(nr.w,staerke.w,dauer.w)
Declare pilz_essen(welchen.w)

IncludeFile "sonstige.pb"           ; Routinen die sonst nirgends reinpassen

; ----------------------------------------------------------------------------------------

IncludeFile "hauptscreen.pb"        ; Routinen zum zeichnen des Hauptschirms
IncludeFile "skills.pb"             ; Screen zum auswhlen der Eigenschaften
IncludeFile "skills_data.pb"        ; Skills initialisieren
IncludeFile "highscore.pb"          ; Highscores anzeigen
IncludeFile "credits.pb"            ; Credits anzeigen
IncludeFile "titel.pb"              ; Startscreen
IncludeFile "buttons.pb"            ; Routinen fuer alle Buttons
IncludeFile "monsterkunde.pb"       ; Monsterinfo ausgeben
IncludeFile "procs_graphics.pb"     ; Prozeduren fr die Grafik
IncludeFile "genlaby.pb"            ; Labyrinth generieren
IncludeFile "maennchen.pb"          ; Routine fuer Spielfigur
IncludeFile "cinfo.pb"              ; Characterinformationen anzeigen
IncludeFile "flueche.pb"            ; Routinen fr Flche
IncludeFile "dumm.pb"
IncludeFile "aufsteigen.pb"         ; Aufsteigen
IncludeFile "inventory.pb"          ; Inventory
IncludeFile "init_gegenstaende.pb"  ; Gegenstaende initialisieren
IncludeFile "vergolden.pb"          ; Zauber vergolden
IncludeFile "hilfe.pb"              ; Hilfe
IncludeFile "sterben.pb"            ; Sterben
IncludeFile "sprites_laden.pb"      ; Alle Sprites laden
IncludeFile "monsterdaten.pb"       ; Monster initialisieren
IncludeFile "kampf.pb"              ; Kaempfen;
IncludeFile "daemon.pb"
IncludeFile "advance.pb"            ; Vor und Nachteile durch Skills
IncludeFile "raeume.pb"             ; Alle Raeume
IncludeFile "optionen.pb"           ; Zum Spiel verlassen
IncludeFile "zaubern.pb"            ; Zaubern
IncludeFile "fallen.pb"             ; Routinen fr alle Fallen
IncludeFile "spell_init.pb"         ; Zauber initialisieren
IncludeFile "fernkampf.pb"          ; Monster Fernkampf
IncludeFile "bogen.pb"              ; Spieler Fernkampf
IncludeFile "stehlen.pb"
IncludeFile "traenke.pb"            ; Potions
IncludeFile "pilze.pb"              ; Mushrooms
IncludeFile "altar.pb"              ; Gegenstaende opfern
IncludeFile "spieler.pb"            ; Anzahl Spieler

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    yplus = 12
    yplus2 = 10
    akt_zauber_offset = 14
    akt_zauber_offset2 = 13
    anzz = 26
  CompilerCase #PB_OS_Linux
    yplus = 10
    yplus2 = 0
    akt_zauber_offset = 16
    akt_zauber_offset2 = 15
    anzz = 30
CompilerEndSelect

;if test = 1
;   yplus = 12
;   yplus2 = 5
;   akt_zauber_offset = 14
;   akt_zauber_offset2 = 13
;   akt_zauber = 3
;   anzz = 26
;endif

; --------------------------------------------------------------------------------------
; Screen ffnen

If InitSprite() = 0
EndIf

If OpenScreen(640,480,32,"Vollbild") = 0
EndIf


sprites_laden()


ClipSprite(0, spieler(akt_spieler) \face*32*2+frame*32, 0, 32, 32)
DisplayTransparentSprite(0, 5*32, 5*32); Variablen setzen
SetFrameRate(60)

If InitSound() = 0
EndIf

; Sound laden
IncludeFile "sounds_laden.pb"

If InitKeyboard() = 0
EndIf

result = InitMouse()

; Highscores initialisieren
For i = 1 To 30
   hscores(i) \name   = " "
   hscores(i) \level  = 0
   hscores(i) \mks    = 0
   hscores(i) \punkte = 0
   hscores(i) \gold   = 0
Next

; Highscores einlesen
If ReadFile(0, "./highscores.dat")
  For i = 1 To 30
     hscores(i) \name    =  ReadString()
     hscores(i) \level   =  ReadWord()
     hscores(i) \mks     =  ReadWord()
     hscores(i) \punkte  =  ReadWord()
     hscores(i) \gold    =  ReadWord()
  Next
  CloseFile(0)
EndIf

again:

; Charactere initialisieren
for i = 1 to #ANZ_SPIELER
	spieler(i) \Maennchen = 2
	spieler(i) \Lifepoints = 12
	spieler(i) \MaxLifepoints = 12
	spieler(i) \LifeGain = 3
	spieler(i) \Mana = 3
	spieler(i) \MaxMana = 3
	spieler(i) \ManaGain = 3
	spieler(i) \Attack = 1
	spieler(i) \Dexterity = 1
	spieler(i) \Strength = 1
	spieler(i) \MaxSpeed = 7
	spieler(i) \Speed = 7
	spieler(i) \Perception = 1
	spieler(i) \Luck_score = 1
	spieler(i) \Power_score = 1
	spieler(i) \Circle = 0
	spieler(i) \light = 1
	spieler(i) \hunger = 0
	spieler(i) \durst = 0
	spieler(i) \schaden_min = 1
	spieler(i) \schaden_max = 3
	spieler(i) \Waffe_attack = 0
	spieler(i) \Waffe_damage = 0
	spieler(i) \Waffe_critical = 0
	spieler(i) \ruestung_min = 0
	spieler(i) \ruestung_max = 0
	spieler(i) \ruestung_behinderung = 0
	spieler(i) \mks = 0
	spieler(i) \gold = 0
	spieler(i) \schleichen = 0
	spieler(i) \fluch = 0
	spieler(i) \fluchdauer = 0
	spieler(i) \gift = 0
	spieler(i) \giftdauer = 0
	spieler(i) \verhungern = 0
	spieler(i) \verdursten = 0
	spieler(i) \weisheit = 0
	spieler(i) \managegenstand  = 0
	spieler(i) \staerkegegenstand = 0
	spieler(i) \zugweitegegenstand = 0
	spieler(i) \dexteritygegenstand = 0
	spieler(i) \gluecksgegenstand = 0
	spieler(i) \dumm = 0

	spieler(i) \face = 2         ; Blickrichtung des Charakters
	spieler(i) \hinterhalt = 0
	spieler(i) \portal = 1
	spieler(i) \teleport = 1
	spieler(i) \nexus = 1
	spieler(i) \stehlen = 2
	spieler(i) \schriftrolle = 0
	spieler(i) \zauberbuch = 0
	spieler(i) \kessel = 0
	spieler(i) \udjat_ben = 1
	spieler(i) \akt_zauber = 1
	spieler(i) \udjat_ben = 1
	spieler(i) \character_x = 1
	spieler(i) \character_y = 1
next

; Aktive Zauber lschen
for j = 1 to #ANZ_SPIELER
   For i = 1 To 15
      aktive (i,j) \nr = 0
      aktive (i,j) \dauer = 0
   Next
next

hinterhalt = -20

; Inventory lschen
for j = 1 to #ANZ_SPIELER
   For i = 1 To 40
      inventory(i,j) \name = 0
      inventory(i,j) \art = 0
      inventory(i,j) \benutzt = 0
      inventory(i,j) \attri1 = 0
      inventory(i,j) \attri2 = 0
      inventory(i,j) \attri3 = 0
      inventory(i,j) \attri4 = 0
      inventory(i,j) \attri5 = 0
   Next
next

zeit = FormatDate("%yyyy%mm%dd%hh%ss",date)
altezeit = FormatDate("%yyyy%mm%dd%hh%ss",date)

init_spells()
init_traenke()
init_pilze()

level = 1


; Titelscreen anzeigen
titel()

; Anzahl Spieler festlegen
select_spieler()

for akt_spieler = 1 to anz_spieler

   ; Spielfigur aussuchen
   maennchen_auswaehlen()

   ; Dann Skills auswhlen
   init_skills()
   select_skills()

   advancements()

next


; Labyrinth initialisieren
groesse = 11
;If test = 1
;   groesse = 22
;EndIf

fallgrube:
gen_laby()

; erstes Zeichnen des Hauptbildschirms
FlipBuffers()


laby_screen()

; Hauptschleife

akt_spieler = 1

Repeat
   ; Tastatureingabe: Bewegen des Charakters
   xmod = 0
   ymod = 0
   ExamineKeyboard()
   If KeyboardPushed(#PB_Key_Right)
      spieler(akt_spieler) \face = 1
      xmod = 1
   EndIf
   If KeyboardPushed(#PB_Key_Left)
      spieler(akt_spieler) \face = 3
      xmod = -1
   EndIf
   If KeyboardPushed(#PB_Key_Up)
      spieler(akt_spieler) \face = 0
      ymod = -1
   EndIf
   If KeyboardPushed(#PB_Key_Down)
      spieler(akt_spieler) \face = 2
      ymod = 1
   EndIf

   result = ExamineMouse()
   mmouse_x = MouseX()
   mmouse_y = MouseY()
   mmouse_links  = MouseButton(1)
   If mmouse_links = 1
      If mmouse_x > 176 And mmouse_x < 352 And mmouse_y >= 160 And mmouse_y <= 192
         spieler(akt_spieler) \face = 1
         xmod = 1
      EndIf
      If mmouse_x < 176 And mmouse_y >= 160 And mmouse_y <= 192
         spieler(akt_spieler) \face = 3
         xmod = -1
      EndIf
      If mmouse_y > 176 And mmouse_y < 352 And mmouse_x >= 160 And mmouse_x <= 192
         spieler(akt_spieler) \face = 2
         ymod = 1
      EndIf
      If mmouse_y < 176 And mmouse_x >= 160 And mmouse_x <= 192
         spieler(akt_spieler) \face = 0
         ymod = -1
      EndIf
   EndIf

   aktion = 0
   ; Prfen des neuen Felds vor der Bewegung
   If xmod<>0 Or ymod<>0
      bewegt = 1

     ; Monster ?
     If labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld  > 200
        If spieler(akt_spieler) \schleichen > 0
           If Random(100) < (luck() * 10) + ((spieler(akt_spieler) \dexterity * 10) / 2)
              If sprache = 0
                 nachricht ("Du schleichst vorbei!")
              Else
                 nachricht ("You sneak by!")
              EndIf
              Delay(600)
              laby_screen()
           Else
              If sprache = 0
                 nachricht ("Du wurdest bemerkt!")
              Else
                 nachricht ("You were spotted!")
              EndIf
              Delay(600)
              xmod = 0
              ymod = 0
              laby_screen()
              spieler(akt_spieler) \Speed = 1
              aktion = 1
           EndIf
        Else
           zw.w = zw - 200
           sprite_x = zw
           sprite_y = 0
           If sprite_x > 10
              Repeat
                 sprite_y = sprite_y + 1
                 sprite_x = sprite_x - 10
              Until sprite_x < 11
           EndIf
           ; Kmpfen!!!
           kampf()
           spieler(akt_spieler) \Speed = 1
           aktion = 1
           xmod = 0
           ymod = 0
        EndIf
     EndIf

     ; Eisblock ?
     If labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld  = #FELD_EIS
        ;Angriff berechnen
        angriff.w = spieler_angriffswert()
        If Random(100) < angriff
           PlaySound(#SOUND_GLASS)
           setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,#FELD_LEER,0,0)
           Delay(400)
           laby_screen()
        Else
           If sprache = 0
              nachricht ("Der Eisblock ist zu hart!")
           Else
              nachricht ("The Iceblock is too strong!")
           EndIf
    If habich(#SPELL_EISSCHILD) = 0
              PlaySound(#SOUND_OW)
              spielerschaden(1,3)
    EndIf
           Delay(400)
        EndIf
        spieler(akt_spieler) \Speed = 1
        aktion = 1
        xmod = 0
        ymod = 0
     EndIf

     ; Falle ?
     If labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld >= #FELD_SPEERFALLE1 And labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld <= #FELD_SPEERFALLE1 + 8
        entdecken.w = spieler(akt_spieler) \perception * 10 + habich(#SPELL_HEXENSICHT) * 10 + habich(#SPELL_FALLENSINN) * 10
        If entdecken > 90
           entdecken = 90
        EndIf
        ; Fallen spueren ?
        If habich(#SPELL_FALLEN_SPUEHREN) > 0
           entdecken = 90
        EndIf
        ; Unaufmerksam ?
        if skills(69,akt_spieler) \gewaehlt = 1
           entdecken = 0
        endif
        If Random(100) < entdecken
           setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,labyrinth(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod)\feld+9,0,0)
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           flipbuffers()
           Delay(400)
        EndIf
     EndIf

     ; Verborgener Schatz ?
     If labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld = #FELD_VERBORGENER_SCHATZ
        entdecken.w = spieler(akt_spieler) \perception * 10 + habich(#SPELL_HEXENSICHT) * 10
        If entdecken > 90
           entdecken = 90
        EndIf
        ; Unaufmerksam ?
        if skills(69,akt_spieler) \gewaehlt = 1
           entdecken = 0
        endif
        If Random(100) < entdecken
           Select(Random(1)+1)
              Case 1:
                 setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,#FELD_GOLD,0,0)
              Case 2:
                 setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,#FELD_TRUHE,0,0)
           EndSelect
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           Delay(400)
        EndIf
     EndIf

     ; Geheimtuere ?
      entdecken.w = spieler(akt_spieler) \perception * 10 + habich(#SPELL_HEXENSICHT) * 10
      If entdecken > 90
         entdecken = 90
      EndIf
      If labyrinth(spieler(akt_spieler) \character_x+1, spieler(akt_spieler) \character_y)\feld = #FELD_GEHEIMGANG
        If Random(100) < entdecken
           setlaby(spieler(akt_spieler) \character_x+1,spieler(akt_spieler) \character_y,#FELD_TUER1,0,0)
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           Delay(400)
        EndIf
     EndIf
      If labyrinth(spieler(akt_spieler) \character_x-1, spieler(akt_spieler) \character_y)\feld = #FELD_GEHEIMGANG
        If Random(100) < entdecken
           setlaby(spieler(akt_spieler) \character_x-1,spieler(akt_spieler) \character_y,#FELD_TUER1,0,0)
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           Delay(400)
        EndIf
     EndIf
      If labyrinth(spieler(akt_spieler) \character_x, spieler(akt_spieler) \character_y+1)\feld = #FELD_GEHEIMGANG
        If Random(100) < entdecken
           setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y+1,#FELD_TUER1,0,0)
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           Delay(400)
        EndIf
      endif
      If labyrinth(spieler(akt_spieler) \character_x, spieler(akt_spieler) \character_y-1)\feld = #FELD_GEHEIMGANG
        If Random(100) < entdecken
           setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y-1,#FELD_TUER1,0,0)
           xmod = 0
           ymod = 0
           PlaySound(#SOUND_EVASION)
           laby_screen()
           Delay(400)
        EndIf
      endif

     ; Raum ?
     If labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld  = #FELD_FRAGEZEICHEN
        raum()
     EndIf

     Select labyrinth(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod)\feld
        Case #FELD_MAUER:
            xmod = 0
            ymod = 0
        Case #FELD_FEUER3:
            xmod = 0
            ymod = 0
        Case #FELD_BAUM1:
            xmod = 0
            ymod = 0
        Case #FELD_BAUM2:
            xmod = 0
            ymod = 0
        Case #FELD_BUECHER1:
            xmod = 0
            ymod = 0
        Case #FELD_BUECHER2:
            xmod = 0
            ymod = 0
        Case #FELD_LABOR1:
            xmod = 0
            ymod = 0
        Case #FELD_LABOR2:
            xmod = 0
            ymod = 0
        Case #FELD_ALTAR1:
            xmod = 0
            ymod = 0
        Case #FELD_GRABSTEIN:
            xmod = 0
            ymod = 0
        Case #FELD_GEHEIMGANG:
            xmod = 0
            ymod = 0
        Case #FELD_TUER2
            ; Picklocks
            If skills(49,akt_spieler) \gewaehlt = 1
               PlaySound(#SOUND_KEY)
               setlaby(spieler(akt_spieler) \character_x+xmod, spieler(akt_spieler) \character_y+ymod,#FELD_OFFENE_TUER,0,0)
               laby_screen()
               Delay(300)
            Else
        PlaySound(#SOUND_OW)
            EndIf
            xmod = 0
            ymod = 0
        Case #FELD_WIEDERGAENGER
            If habich(#SPELL_LIED_DES_TODES) = 0
               aufstehen(22)
               setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,monster(4) \nr + 200,monster(4) \lebenspunkte,4)
               xmod = 0
               ymod = 0
               angreifen = 1
               laby_screen()
               PlaySound(#SOUND_MOAN)
            EndIf
        Case #FELD_SKELETT
            If spieler(akt_spieler) \fluch = #FLUCH_DES_HADES
               aufstehen(22)
               setlaby(spieler(akt_spieler) \character_x+xmod,spieler(akt_spieler) \character_y+ymod,monster(4) \nr + 200,monster(4) \lebenspunkte,4)
               xmod = 0
               ymod = 0
               angreifen = 1
               laby_screen()
               PlaySound(#SOUND_MOAN)
            EndIf
     EndSelect
      ;zu weit oben oder links
      If spieler(akt_spieler) \character_x+xmod < 1 Or spieler(akt_spieler) \character_y+ymod < 1
         xmod = 0
         ymod = 0
         aktion = 1
      EndIf
   Else
      bewegt = 0
   EndIf


      ;Bewegen wir uns ?
      If xmod <> 0 Or ymod <> 0 Or aktion = 1
         spieler(akt_spieler) \Speed = spieler(akt_spieler) \Speed - 1
  ; Song of Life ?
  If habich(#SPELL_LIED_DES_LEBENS) = 1
     spieler(akt_spieler) \Lifepoints = spieler(akt_spieler) \Lifepoints + 1
     If spieler(akt_spieler) \Lifepoints > spieler(akt_spieler) \MaxLifepoints
               spieler(akt_spieler) \Lifepoints = spieler(akt_spieler) \MaxLifepoints
     EndIf
  EndIf
          ; Neue Runde ?
	  zwspeed.w = spieler(akt_spieler) \Speed
	  if anz_spieler > 1
	     zwspeed = zwspeed + 1
	  endif
         ;If spieler(akt_spieler) \Speed < 1 Or aktion = 1
         If zwspeed < 1 Or aktion = 1
nach_zauber:
            angreifen = 1
            spieler(akt_spieler) \Speed = spieler(akt_spieler) \MaxSpeed + habich(#SPELL_RUECKENWIND)
            ; Schleichen macht langsamer!
            If spieler(akt_spieler) \schleichen > 0
               spieler(akt_spieler) \Speed = spieler(akt_spieler) \Speed - 2
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_PARALYSE
               spieler(akt_spieler) \Speed = 1
            EndIf
            ; Verdursten!
            spieler(akt_spieler) \Durst = spieler(akt_spieler) \Durst + 1
            If spieler(akt_spieler) \fluch = #FLUCH_DER_NAIADEN
               spieler(akt_spieler) \Durst = spieler(akt_spieler) \Durst + 1
            EndIf
            If spieler(akt_spieler) \Durst < 30
               spieler(akt_spieler) \verdursten = 0
            EndIf
            If spieler(akt_spieler) \Durst > 29 And spieler(akt_spieler) \Durst < 45
               spieler(akt_spieler) \verdursten = 1
            EndIf
            If spieler(akt_spieler) \Durst > 44 And spieler(akt_spieler) \Durst < 50
               spieler(akt_spieler) \verdursten = 2
            EndIf
            If spieler(akt_spieler) \Durst > 49
               spieler(akt_spieler) \verdursten = 3
               spielerschaden(1,3)
            EndIf
            ;Verhungern!
            spieler(akt_spieler) \hunger = spieler(akt_spieler) \hunger + 1
            If spieler(akt_spieler) \fluch = #FLUCH_DES_DAGDA
               spieler(akt_spieler) \hunger = spieler(akt_spieler) \hunger + 1
            EndIf
            If spieler(akt_spieler) \hunger < 40
               spieler(akt_spieler) \verhungern = 0
            EndIf
            If spieler(akt_spieler) \hunger > 39 And spieler(akt_spieler) \hunger < 60
               spieler(akt_spieler) \verhungern = 1
            EndIf
            If spieler(akt_spieler) \hunger > 59 And spieler(akt_spieler) \hunger < 80
               spieler(akt_spieler) \verhungern = 2
            EndIf
            If spieler(akt_spieler) \hunger > 79
               spieler(akt_spieler) \verhungern = 3
               spielerschaden(1,3)
            EndIf

            ;Zeit Aktiver Zauber und Gegenstnde verkrzen
            For i = 1 To 15
               If aktive(i,akt_spieler) \dauer > 0
                  If aktive(i,akt_spieler) \dauer <> 999
                     aktive(i,akt_spieler) \dauer = aktive(i,akt_spieler) \dauer - 1
                  EndIf
               EndIf
               If aktive(i,akt_spieler) \dauer < 1
                  aktive(i,akt_spieler) \nr = 0
                  aktive(i,akt_spieler) \staerke = 0
               EndIf
            Next

             ; Lampen und Fackeln
             For i = 1 To 40
                 ; Fackel ?
                 If inventory(i,akt_spieler) \benutzt = 1 And inventory(i,akt_spieler) \name = #OBJGRAFIK_FACKEL1
                    inventory(i,akt_spieler) \attri1 = inventory(i,akt_spieler) \attri1 - 1
                    If inventory(i,akt_spieler) \attri1 < 1
                       inventory(i,akt_spieler) \benutzt = 0
                       spieler(akt_spieler) \light = spieler(akt_spieler) \light - 3
                    EndIf
                 EndIf
                 ; Lampe ?
                 If inventory(i,akt_spieler) \benutzt = 1 And inventory(i,akt_spieler) \name = #OBJGRAFIK_LAMPE1
                    inventory(i,akt_spieler) \attri1 = inventory(i,akt_spieler) \attri1 - 1
                    If inventory(i,akt_spieler) \attri1 < 1
                       inventory(i,akt_spieler) \benutzt = 0
                       spieler(akt_spieler) \light = spieler(akt_spieler) \light - 4
                    EndIf
                 EndIf
              Next

              ;Fluch
              If spieler(akt_spieler) \fluchdauer = 1   ; Fluch zuende ?
                 spieler(akt_spieler) \fluchdauer = 0
                 spieler(akt_spieler) \fluch = 0
              EndIf
              If spieler(akt_spieler) \fluchdauer > 1
                 spieler(akt_spieler) \fluchdauer = spieler(akt_spieler) \fluchdauer - 1
              EndIf

              ;Gift
              If spieler(akt_spieler) \giftdauer = 1   ; Gift ausgestanden ?
                 spielerschaden(spieler(akt_spieler) \gift,2)
                 spieler(akt_spieler) \giftdauer = 0
                 spieler(akt_spieler) \gift = 0
              EndIf
              If spieler(akt_spieler) \giftdauer > 1
                 If spieler(akt_spieler) \fluch <> #FLUCH_DES_APOPHIS
                    spieler(akt_spieler) \giftdauer = spieler(akt_spieler) \giftdauer - 1

                    ; Giftresistenz ?
                    If spieler(akt_spieler) \giftdauer > 1 And skills(55,akt_spieler) \gewaehlt = 1
                       spieler(akt_spieler) \giftdauer = spieler(akt_spieler) \giftdauer - 1
                    EndIf
                 EndIf
                 ; Schwaeche Gift ?
                 If skills(71,akt_spieler) \gewaehlt = 1
                    spielerschaden(spieler(akt_spieler) \gift + 1,2)
                 Else
                    spielerschaden(spieler(akt_spieler) \gift,2)
                 EndIf
              EndIf


            ; Hinterhalt ?
            hinterhalt = hinterhalt + 1
            If spieler(akt_spieler) \fluch = #FLUCH_DES_MARDUK
               hinterhalt = hinterhalt + 1
            EndIf
            If Random(100) < hinterhalt And habich(#SPELL_LIED_DER_EINSAMKEIT) = 0
               xmod = 0
               ymod = 0
               hinterhalt = -20
               rad = Random(20) + 1
               i = 1
               gef = 0
               welches = 0
               Repeat
                  If monster(i) \eigenschaft1 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft2 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft3 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft4 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft5 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft6 = 2
                     gef = 1
                  EndIf
                  If monster(i) \eigenschaft7 = 2
                     gef = 1
                  EndIf
                  i = i + 1
                  If i > #ANZ_MONSTER Or i > level * 2
                     i = 1
                  EndIf
                  If gef = 1
                     gef = 0
                     rad = rad - 1
                     If rad < 1
                        welches = i
                     EndIf
                  EndIf
               Until welches > 0
               ; Setzen!
               welches = welches - 1
               gesetzt.b = 0
               If labyrinth(spieler(akt_spieler) \character_x+1,spieler(akt_spieler) \character_y) \feld = #FELD_LEER
                  gesetzt = 1
                  setlaby(spieler(akt_spieler) \character_x+1,spieler(akt_spieler) \character_y,monster(welches) \nr + 200, monster(welches) \lebenspunkte,welches)
               EndIf
               If labyrinth(spieler(akt_spieler) \character_x-1,spieler(akt_spieler) \character_y) \feld = #FELD_LEER
                  gesetzt = 1
                  setlaby(spieler(akt_spieler) \character_x-1,spieler(akt_spieler) \character_y,monster(welches) \nr + 200,monster(welches) \lebenspunkte,welches)
               EndIf
               If labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y+1) \feld = #FELD_LEER
                  gesetzt = 1
                  setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y+1,monster(welches) \nr + 200,monster(welches) \lebenspunkte,welches)
               EndIf
               If labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y-1) \feld = #FELD_LEER
                  gesetzt = 1
                  setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y-1,monster(welches) \nr + 200,monster(welches) \lebenspunkte,welches)
               EndIf
               if gesetzt = 1
                  If sprache = 0
                     nachricht ("Ein Hinterhalt!")
                  Else
                     nachricht ("An ambush!")
                  EndIf
                  FlipBuffers()
                  Delay(600)
                  laby_screen()
               endif
            EndIf  ; Hinterhalt

; Nchster Spieler
if anz_spieler > 1
 akt_spieler = akt_spieler + 1
  if akt_spieler > anz_spieler
     akt_spieler = 1
  endif
  xmod = 0
  ymod = 0
  laby_screen()
  delay(200)
endif

            ;neues monster
            If level > 3 And Random(40) > 30
               Repeat
                  x=Random(groesse-3)+2
                  y=Random(groesse-3)+2
               Until labyrinth(x,y)\feld=#FELD_LEER
        Repeat
           hugo = Random(level*2) + 1
        Until hugo < #ANZ_MONSTER + 1 And hugo < level + 2
               setlaby(x,y,monster(hugo) \nr + 200,monster(hugo) \lebenspunkte,hugo)

               spieler(akt_spieler) \Speed = spieler(akt_spieler) \MaxSpeed
     EndIf
         EndIf
      EndIf

; Monster greifen an
If angreifen = 1
      angreifen = 0
      nach_kampf = 1
      ; Nahkampf
      If labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y+1) \feld > 200
         monster_angriff(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y+1)
      EndIf
      If labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y-1) \feld > 200
         monster_angriff(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y-1)
      EndIf
      If labyrinth(spieler(akt_spieler) \character_x+1,spieler(akt_spieler) \character_y) \feld > 200
         monster_angriff(spieler(akt_spieler) \character_x+1,spieler(akt_spieler) \character_y)
      EndIf
      If labyrinth(spieler(akt_spieler) \character_x-1,spieler(akt_spieler) \character_y) \feld > 200
         monster_angriff(spieler(akt_spieler) \character_x-1,spieler(akt_spieler) \character_y)
      EndIf
      ; Fernkampf
      fernkampf()
EndIf



   laby_rahmen()
   show_logo()

   wohin = ScreenOutput()
   StartDrawing(wohin)
   FrontColor(0,0,0)
   Box(400,110,150,50)
   StopDrawing()

   show_varys()
   zw_bild = 0
   show_buttons()
   If zw_bild <> 0
      Select zw_bild
         Case 1
            ; Hilfe darstellen
            zw_bild = 0
            hilfe()
         Case 2
            ; Inventar darstellen
            zw_bild = 0
            inv()
            laby_screen()
            Goto nach_zauber
         Case 3
            ; Zaubermenue darstellen
            zw_bild = 0
            zaubern()
            laby_screen()
            Goto nach_zauber
         Case 4
            ; Klettern
            zw_bild = 0
               If skills(51,akt_spieler) \gewaehlt = 1 And labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y) \feld = #FELD_SCHACHT
                  if sprache = 0
                     nachricht("Du kletterst hinab!")
                  else
                     nachricht("You climb down!")
                  endif
                  delay(600)
                  aufsteigen()
                  neuer_level()
               EndIf
         Case 5
            ; Optionen
            zw_bild = 0
            optionen()
            laby_screen()
            flipbuffers()
         Case 6
            zw_bild = 0
            character_info()
            laby_screen()
            flipbuffers()
         Case 7
            zw_bild = 0
            monsterkunde()
            laby_screen()
            flipbuffers()
         Case 8
            zw_bild = 0
            If skills(48,akt_spieler) \gewaehlt = 1
               If spieler(akt_spieler) \schleichen = 0
                  spieler(akt_spieler) \schleichen = 1
               Else
                  spieler(akt_spieler) \schleichen = 0
               EndIf
               laby_screen()
            flipbuffers()
               Delay(400)
            EndIf
         Case 9
            zw_bild = 0
            bogen()
            laby_screen()
            flipbuffers()
         Case 10
            zw_bild = 0
            stehlen()
            laby_screen()
            flipbuffers()
   EndSelect
   Else
      ; Zeichnen des Hauptbildschirms
      schongemalt = 0
      If xmod<>0 Or ymod<>0
         For i=4 To 32 Step 4
            framestep = framestep+1
            If framestep >3
               framestep = 0
               If frame = 0
                  frame = 1
               Else
                  frame = 0
               EndIf
            EndIf

            ClearScreen(0, 0, 0)
            draw_screen(xmod*i*(-1) , ymod*i*(-1))
            draw_character(spieler(akt_spieler) \face, frame)

            laby_rahmen()
            show_logo()
            show_varys()
            show_buttons()
            show_sight()

            result = ExamineMouse()
            mmouse_x = MouseX()
            mmouse_y = MouseY()
            mmouse_links  = MouseButton(1)
            mmouse_rechts = MouseButton(2)
            ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
            DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)
            FlipBuffers()
            schongemalt = 1
         Next
         spieler(akt_spieler) \character_x = spieler(akt_spieler) \character_x + xmod
         spieler(akt_spieler) \character_y = spieler(akt_spieler) \character_y + ymod
      EndIf  ; if xmod
   EndIf   ; if zwischenbild


; Prfen des Feldes nach der Bewegung
   falle()
   Select labyrinth(spieler(akt_spieler) \character_x, spieler(akt_spieler) \character_y)\feld
      Case #FELD_ALTAR2
           ; Gottlos ?
           If skills(47,akt_spieler) \gewaehlt = 0
              altar()
              spieler(akt_spieler) \character_y = spieler(akt_spieler) \character_y - 1
              laby_screen()
           EndIf
      Case #FELD_AUSGANG ; Ausgang
         aufsteigen()
         neuer_level()
         laby_screen()
       Case #FELD_GRUENETRUHE2
              mag_geg.w = 0
              i = 0
              Repeat
                 i = i + 1
              Until i > 40 Or inventory(i,akt_spieler) \name = 0   ; Platz vorhanden!
              If i < 41
                 hugo = Random(12) + 1
                 If test = 1
                    hugo = 6
                 EndIf
                 Select(hugo)
                    Case 1
                       mag_geg = #OBJGRAFIK_ZAUBERERHUT
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_ZAUBERERHUT
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_ZAUBERERHUT) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_ZAUBERERHUT) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_ZAUBERERHUT) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_ZAUBERERHUT) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_ZAUBERERHUT) \attri4
                    Case 2
                       mag_geg = #OBJGRAFIK_HANDSCHUHE3
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_HANDSCHUHE3
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_HANDSCHUHE3) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_HANDSCHUHE3) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_HANDSCHUHE3) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_HANDSCHUHE3) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_HANDSCHUHE3) \attri4
                    Case 3
                       mag_geg = #OBJGRAFIK_STIEFEL_DUNKEL
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_STIEFEL_DUNKEL
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_STIEFEL_DUNKEL) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_STIEFEL_DUNKEL) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_STIEFEL_DUNKEL) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_STIEFEL_DUNKEL) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_STIEFEL_DUNKEL) \attri4
                    Case 4
                       mag_geg = #OBJGRAFIK_FLAMMENSCHWERT
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_FLAMMENSCHWERT
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_FLAMMENSCHWERT) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_FLAMMENSCHWERT) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_FLAMMENSCHWERT) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_FLAMMENSCHWERT) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_FLAMMENSCHWERT) \attri4
                    Case 5
                       mag_geg = #OBJGRAFIK_EISSCHWERT
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_EISSCHWERT
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_EISSCHWERT) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_EISSCHWERT) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_EISSCHWERT) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_EISSCHWERT) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_EISSCHWERT) \attri4
                    Default
                       hugo = Random(7)
                       mag_geg = #OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo
                       inventory(i,akt_spieler) \name = #OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo
                       inventory(i,akt_spieler) \art  = gegenstand(#OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo) \art
                       inventory(i,akt_spieler) \benutzt = 0
                       inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo) \attri1
                       inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo) \attri2
                       inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo) \attri3
                       inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_ZAUBERSTAB_GRUEN+hugo) \attri4
                 EndSelect
              EndIf
              PlaySound(#SOUND_SUCCESS)
              setlaby(spieler(akt_spieler) \character_x, spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
              ;character wieder zeigen
             ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
             DisplaySprite(#SPRITE_TILESET_LABYRINTH, 160, 160)  ; Erst Gang
             draw_character(spieler(akt_spieler) \face, frame) ; Dann Character
             If sprache = 0
                nachricht("Du findest: " + gegenstand(mag_geg) \name_d)
             Else
                nachricht("You found: " + gegenstand(mag_geg) \name_e)
             EndIf
      FlipBuffers()
             Delay(600)

       Case #FELD_GOLD  ; Hier gibts Kohle!
          If spieler(akt_spieler) \fluch <> #FLUCH_DES_LEPRECHAUN
             hugo = Random(level*5)
             spieler(akt_spieler) \gold = spieler(akt_spieler) \gold + hugo
             setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
             PlaySound(#SOUND_SUCCESS)
             ;character wieder zeigen
             ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
             DisplaySprite(#SPRITE_TILESET_LABYRINTH, 160, 160)  ; Erst Gang
             draw_character(spieler(akt_spieler) \face, frame) ; Dann Character
             If sprache = 0
                nachricht("Du findest " + Str(hugo) + " Goldstuecke")
             Else
                nachricht("You found " + Str(hugo) + " Gold")
             EndIf
      FlipBuffers()
             Delay(600)
          Else
             If sprache = 0
                nachricht ("Fluch des Leprechaun!")
             Else
                nachricht ("curse of leprechaun!")
             EndIf
      FlipBuffers()
             Delay(600)
          EndIf

       Case #FELD_TRUHE  ; Hier gibts Gegenstaende!
             hugo = Random(3)+1
             i = 0
             Repeat
                i = i + 1
             Until inventory(i,akt_spieler) \name = 0
             Select(hugo)
                Case 1:hugo = Random(14)+1
                  inventory(i,akt_spieler) \name = #OBJGRAFIK_HELM1+hugo
                  inventory(i,akt_spieler) \art = gegenstand(#OBJGRAFIK_HELM1+hugo) \art
                  inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_HELM1+hugo) \attri1
                  inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_HELM1+hugo) \attri2
                  inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_HELM1+hugo) \attri3
                  inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_HELM1+hugo) \attri4
                Case 2:hugo = Random(20)+1
                  inventory(i,akt_spieler) \name = #OBJGRAFIK_DOLCH+hugo
                  inventory(i,akt_spieler) \art = gegenstand(#OBJGRAFIK_DOLCH+hugo) \art
                  inventory(i,akt_spieler) \attri1 = gegenstand(#OBJGRAFIK_DOLCH+hugo) \attri1
                  inventory(i,akt_spieler) \attri2 = gegenstand(#OBJGRAFIK_DOLCH+hugo) \attri2
                  inventory(i,akt_spieler) \attri3 = gegenstand(#OBJGRAFIK_DOLCH+hugo) \attri3
                  inventory(i,akt_spieler) \attri4 = gegenstand(#OBJGRAFIK_DOLCH+hugo) \attri4
                Case 3:hugo = Random(14)+1
                  hugo=Random(1)+1
                  If hugo = 1
                     obj = #OBJGRAFIK_APFEL+random(9)
                  EndIf
                  If hugo= 2
                     obj = #OBJGRAFIK_SCHINKEN+random(2)
                  EndIf
                  inventory(i,akt_spieler) \name = obj
                  inventory(i,akt_spieler) \art = gegenstand(obj) \art
                  inventory(i,akt_spieler) \attri1 = gegenstand(obj) \attri1
                  inventory(i,akt_spieler) \attri2 = gegenstand(obj) \attri2
                  inventory(i,akt_spieler) \attri3 = gegenstand(obj) \attri3
                  inventory(i,akt_spieler) \attri4 = gegenstand(obj) \attri4
                case 4:
                i = 0
   repeat
      i = i + 1
   until inventory(i,akt_spieler) \name = 0

      welcher.w = random(5)+1
      obje.w = 0
      select(welcher)
       case 1
          obje = #OBJGRAFIK_EDELSTEIN_TUERKIS
       case 2
          obje = #OBJGRAFIK_EDELSTEIN_GELB
       case 3
          obje = #OBJGRAFIK_EDELSTEIN_BLAU
       case 4
          obje = #OBJGRAFIK_EDELSTEIN_ROT
       case 5
          obje = #OBJGRAFIK_BERNSTEIN
       case 6
          obje = #OBJGRAFIK_EDELSTEIN_GRUEN
      endselect
      inventory(i,akt_spieler) \name = obje
      inventory(i,akt_spieler) \art  = 16   ; Edelstein
      inventory(i,akt_spieler) \benutzt = 0
      i = i + 1
             EndSelect

             setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
             PlaySound(#SOUND_SUCCESS)
             ;character wieder zeigen
             ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
             DisplaySprite(#SPRITE_TILESET_LABYRINTH, 160, 160)  ; Erst Gang
             draw_character(spieler(akt_spieler) \face, frame) ; Dann Character
             If sprache = 0
                nachricht("Du findest " + gegenstand(obj) \name_d)
             Else
                nachricht("You found " + gegenstand(obj) \name_e)
             EndIf
      FlipBuffers()
             Delay(600)

       Case #FELD_NEXUS
          If spieler(akt_spieler) \Mana < spieler(akt_spieler) \MaxMana + spieler(akt_spieler) \managegenstand
             If spieler(akt_spieler) \fluch <> #FLUCH_DES_SETH
                spieler(akt_spieler) \Mana = spieler(akt_spieler) \MaxMana + spieler(akt_spieler) \managegenstand
                For i = 1 To 15
                   If aktive(i,akt_spieler) \dauer > 0 And aktive(i,akt_spieler) \dauer <> 999
                      aktive(i,akt_spieler) \nr = 0
                      aktive(i,akt_spieler) \staerke = 0
                      aktive(i,akt_spieler) \dauer = 0
                   EndIf
                Next
                PlaySound(#SOUND_HARP)
                sternchen(160,160,3)
                laby_screen()
             Else
                If sprache = 0
                   nachricht ("Fluch des Seth!")
                Else
                   nachricht ("Curse of Seth!")
                EndIf
                Delay(600)
             EndIf
          EndIf
       Case #FELD_PILZ1
          if random(100) > spieler(akt_spieler) \perception * 10 + luck() * 10
             i = 0
             repeat
                i = i + 1
             until inventory(i,akt_spieler) \name = 0

                obje.w = random(9)+#OBJGRAFIK_PILZE_SCHWARZ
                inventory(i,akt_spieler) \name = obje
                inventory(i,akt_spieler) \art  = 17   ; Pilz
                inventory(i,akt_spieler) \benutzt = 0
                inventory(i,akt_spieler) \attri1 = random(9)+1

             setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
             PlaySound(#SOUND_SUCCESS)
             ;character wieder zeigen
             ClipSprite(#SPRITE_TILESET_LABYRINTH, 128, 0, 32, 32)
             DisplaySprite(#SPRITE_TILESET_LABYRINTH, 160, 160)  ; Erst Gang
             draw_character(spieler(akt_spieler) \face, frame) ; Dann Character
             If sprache = 0
                nachricht("Du findest einen Pilz!")
             Else
                nachricht("You found a mushroom!")
             EndIf
             FlipBuffers()
             Delay(600)
          endif
       Case #FELD_GIFT
          spieler(akt_spieler) \giftdauer = spieler(akt_spieler) \giftdauer + 1
          If spieler(akt_spieler) \gift = 0
             spieler(akt_spieler) \gift = 1
          EndIf
          setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
       Case #FELD_FEUER1
          ; Feuerschild ?
          If habich(#SPELL_FEUERSCHILD) = 0
             spielerschaden(1,1)
             setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
          EndIf
       Case #FELD_FEUER2
          ; Feuerschild ?
          If habich(#SPELL_FEUERSCHILD) = 0
             spielerschaden(2,1)
             setlaby(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y,#FELD_LEER,0,0)
          EndIf
       Case #FELD_SANKTUM
          ;Gottlos?
          If skills(74,akt_spieler) \gewaehlt = 0 Or spieler(akt_spieler) \fluch = #FLUCH_DES_OSIRIS
             If spieler(akt_spieler) \Lifepoints < spieler(akt_spieler) \MaxLifepoints
                If Random(100) > 50
            nach_kampf = 1
            spieler(akt_spieler) \Lifepoints = spieler(akt_spieler) \MaxLifepoints
            PlaySound(#SOUND_HOLY)
            For j = 1 To 5
                      For i = 1 To 4
                         ClipSprite(#SPRITE_TILESET_ANIMATIONEN, i*40-40, 1, 39, 39)
                         DisplayTransparentSprite(#SPRITE_TILESET_ANIMATIONEN, 156, 156)
                  FlipBuffers()
                  Delay(70)
               Next
            Next
         EndIf
      EndIf
      ; Akolyth ?
      If skills(25,akt_spieler) \gewaehlt = 1
         For i = 1 To 15
            If aktive(i,akt_spieler) \dauer > 0 And aktive(i,akt_spieler) \dauer <> 999
               aktive(i,akt_spieler) \nr = 0
               aktive(i,akt_spieler) \staerke = 0
               aktive(i,akt_spieler) \dauer = 0
            EndIf
         Next
         spieler(akt_spieler) \gift = 0
         spieler(akt_spieler) \giftdauer = 0
         spieler(akt_spieler) \fluch = 0
         spieler(akt_spieler) \fluchdauer = 0
         spieler(akt_spieler) \Mana = spieler(akt_spieler) \MaxMana  + spieler(akt_spieler) \managegenstand
      EndIf
   EndIf
   laby_screen()
       Case #FELD_HAENDLER1
          haendler()
          spieler(akt_spieler) \character_x = spieler(akt_spieler) \character_x + 1
          laby_screen()
          laby_screen()
       Case #FELD_WASSER
          If bewegt = 1
             PlaySound(#SOUND_SPLASH)
             If skills(56,akt_spieler) \gewaehlt = 0
                ; Fliegen ?
                If habich(#SPELL_FLIEGEN) = 0
                   ; Wassergehen ?
                   If habich(#SPELL_UEBERS_WASSER_GEHEN) = 0
                      spielerschaden(1,3)
                   EndIf
                EndIf
             EndIf
          EndIf
       Case #FELD_BRUNNEN
          If bewegt = 1
             If sprache = 0
                nachricht ("Du fuellst dein Wasser auf!")
             Else
                nachricht ("You refill your water!")
             EndIf
             PlaySound(#SOUND_SPLASH)
             Delay(600)
	     spieler(akt_spieler) \Durst = 0
             spieler(akt_spieler) \verdursten = 0
             For i = 1 To 40
                If inventory(i,akt_spieler) \name = #OBJGRAFIK_WASSERSCHLAUCH
                   inventory(i,akt_spieler) \attri1 = 7
                EndIf
             Next
          EndIf
       Case #FELD_TELEPORTER
          If bewegt = 1
             PlaySound(#SOUND_SUCCESS)
             sternchen(156,156,4)
             xsave = spieler(akt_spieler) \character_x
             spieler(akt_spieler) \character_x = labyrinth(spieler(akt_spieler) \character_x,spieler(akt_spieler) \character_y) \lebenspunkte
             spieler(akt_spieler) \character_y = labyrinth(xsave,spieler(akt_spieler) \character_y) \objekt
             laby_screen()
             nach_kampf = 1
          EndIf
       Case #FELD_LAGERFEUER
          ; Feuerschild ?
          If bewegt = 1 And habich(#SPELL_FEUERSCHILD) = 0
             PlaySound(#SOUND_OW)
             spielerschaden(1,1)
             laby_screen()
          EndIf
   EndSelect

   nach_splash = 0
   If zw_bild > 0
      nach_splash = 1
      FlipBuffers()
   EndIf

   If nach_kampf = 1
      FlipBuffers()
      nach_kampf = 0
   EndIf


   result = ExamineMouse()
   mmouse_x = MouseX()
   mmouse_y = MouseY()
   mmouse_links  = MouseButton(1)
   mmouse_rechts = MouseButton(2)

   If mmouse_x <> mouse_x_old Or mmouse_y <> mouse_y_old Or nach_splash = 1
      If schongemalt = 0
      ClearScreen(0, 0, 0)
      draw_screen(xmod*i*(-1) , ymod*i*(-1))
      draw_character(spieler(akt_spieler) \face, frame)
      laby_rahmen()
      show_logo()
      show_varys()
      show_buttons()
      show_sight()

      result = ExamineMouse()
      mmouse_x = MouseX()
      mmouse_y = MouseY()
      mmouse_links  = MouseButton(1)
      mmouse_rechts = MouseButton(2)
      ClipSprite(#SPRITE_TILESET_ITEMS, 192, 288, 32, 32)
      DisplayTransparentSprite(#SPRITE_TILESET_ITEMS, mmouse_x, mmouse_y)

      FlipBuffers()
      mouse_x_old = mmouse_x
      mouse_y_old = mmouse_y
      EndIf
   EndIf


Until EventID = #PB_EventCloseWindow

; Programmende
End
; ExecutableFormat=Windows
; EOF
