; Routinen zum zeichnen des Hauptschirms

; -------------------------------------------------------------------------------------

Procedure vertical(x,y)

   For z = 1 To 9
      For i = 1 To 5
         ClipSprite(#SPRITE_TILESET_RAHMEN, 1, 96 + (i * 16 - 16), 16, 16)
         DisplayTransparentSprite(#SPRITE_TILESET_RAHMEN, x * 15 - 15, y)
         x = x + 1
      Next
   Next

EndProcedure

; -------------------------------------------------------------------------------------

Procedure vertical2(x,y)

   For z = 1 To 5
      For i = 1 To 5
         ClipSprite(#SPRITE_TILESET_RAHMEN, 1, 96 + (i * 16 - 16), 16, 16)
         DisplayTransparentSprite(#SPRITE_TILESET_RAHMEN, x * 15 - 15, y)
         x = x + 1
      Next
   Next

EndProcedure

; -------------------------------------------------------------------------------------

Procedure vertical3(x,y)

   For z = 1 To 4
      For i = 1 To 5
         ClipSprite(#SPRITE_TILESET_RAHMEN, 1, 96 + (i * 16 - 16), 16, 16)
         DisplayTransparentSprite(#SPRITE_TILESET_RAHMEN, x * 15 - 15, y)
         x = x + 1
      Next
   Next

EndProcedure

; -------------------------------------------------------------------------------------

Procedure horizontal(x,y)

   For z = 1 To 7
      For i = 1 To 5
         ClipSprite(#SPRITE_TILESET_RAHMEN, 1, 1 + (i * 16 - 16), 16, 16)
         DisplayTransparentSprite(#SPRITE_TILESET_RAHMEN, x, y * 15 - 15)
         y = y + 1
      Next
   Next

EndProcedure

; -------------------------------------------------------------------------------------

Procedure laby_rahmen()

   vertical(1,1)
   vertical(1,465)
   horizontal(1,1)
   horizontal(624,1)
   horizontal(350,1) ;350
   vertical2(1,350)
   vertical3(25,90)
   
   wohin = ScreenOutput()
   StartDrawing(wohin)
   FrontColor(0,0,0)
   Box(365,15,51,449) ; berbleibsel des Labyrinths bermalen
   Box(15,365,335,51) ; berbleibsel des Labyrinths bermalen
   StopDrawing()

   vertical3(25,90)
   vertical3(25,165)
   vertical3(25,345)

EndProcedure

; --------------------------------------------------------------------------------------

Procedure show_logo()

   ClipSprite(#SPRITE_TILESET_LOGO2, 1, 1, 200, 58)
   DisplayTransparentSprite(#SPRITE_TILESET_LOGO2, 400, 25)

EndProcedure

; --------------------------------------------------------------------------------------
; Prozedur Spielervariablen anzeigen

Procedure show_varys()

Shared sprache, spieler, akt_spieler, level, aktive, zauber

   wohin = ScreenOutput()

   StartDrawing(wohin)
      DrawingMode(1)

      x = 400
      y = 110
      Locate(x,y)
      FrontColor(0,0,0)
      Box(400,110,160,55)  ; Muell bermalen
      FrontColor(255,255,255)
      If sprache = 0
         DrawText("Lebenspunkte:")
      Else
         DrawText("Lifepoints:")
      EndIf
      Locate(x+110,y)
      DrawText(Str(spieler(akt_spieler) \Lifepoints) + "/" + Str(spieler(akt_spieler) \MaxLifepoints))

      Locate(x,y+15)
      DrawText("Mana:")
      Locate(x+115,y+15)
      DrawText(Str(spieler(akt_spieler) \Mana) + "/" + Str(spieler(akt_spieler) \MaxMana + spieler(akt_spieler) \managegenstand))

      Locate(x,y+30)
      If sprache = 0
         DrawText("Zugweite:")
      Else
         DrawText("Moves:")
      EndIf
      Locate(x+115,y+30)
      ;DrawText(Str(spieler(akt_spieler) \Speed) + "/" + Str(spieler(akt_spieler) \MaxSpeed + spieler(akt_spieler) \mag_speed))
      DrawText(Str(spieler(akt_spieler) \Speed) + "/" + Str(spieler(akt_spieler) \MaxSpeed + habich(40)))

      Locate(x,y+45)
      DrawText("Level:")
      Locate(x+115,y+45)
      DrawText(Str(Level))

      ; Aktives Zeug
      x = 400
      y = 175
      FrontColor(0,0,0)    ; Schwarz
      Box(400,180,160,60)  ; Muell bermalen
      If spieler(akt_spieler) \schleichen > 0
         y = y + 10
         Locate(x,y)
         FrontColor(150,150,150)  ; Grau
         If sprache = 0
            DrawText("Schleichen")
         Else
            DrawText("Stealth")
         EndIf
      EndIf

      frontcolor(255,255,1)   ; Gelb
      for i = 1 to 15
         if aktive(i,akt_spieler) \nr > 0
            y = y + 10
            locate(x,y)
            if sprache = 0
               drawtext(zauber(aktive(i,akt_spieler) \nr) \name_d + " " + str(aktive(i,akt_spieler) \staerke) + " " + str(aktive(i,akt_spieler) \dauer))
            else
               drawtext(zauber(aktive(i,akt_spieler) \nr) \name_e + " " + str(aktive(i,akt_spieler) \staerke) + " " + str(aktive(i,akt_spieler) \dauer))
            endif
         endif
      next

      If spieler(akt_spieler) \gift > 0
         y = y + 10
         Locate(x,y)
         FrontColor(1,255,1)  ; Grn
         If sprache = 0
            DrawText("Vergiftet " + Str(spieler(akt_spieler) \gift))
         Else
            DrawText("Poisened " + Str(spieler(akt_spieler) \gift))
         EndIf
      EndIf
      If spieler(akt_spieler) \verhungern > 0
         y = y + 10
         Locate(x,y)
         FrontColor(1,1,255)  ; Blau
         If sprache = 0
            Select spieler(akt_spieler) \verhungern
               Case 1 : DrawText("Hungrig")
               Case 2 : DrawText("Sehr Hungrig")
               Case 3 : DrawText("Am verhungern")
            EndSelect
         Else
            Select spieler(akt_spieler) \verhungern
               Case 1 : DrawText("Hungry")
               Case 2 : DrawText("Very Hungry")
               Case 3 : DrawText("Starving (Hunger)")
            EndSelect
         EndIf
      EndIf
      If spieler(akt_spieler) \verdursten > 0
         y = y + 10
         Locate(x,y)
         FrontColor(1,1,255)  ; Blau
         If sprache = 0
            Select spieler(akt_spieler) \verdursten
               Case 1 : DrawText("Durstig")
               Case 2 : DrawText("Sehr Durstig")
               Case 3 : DrawText("Am verdursten")
            EndSelect
         Else
            Select spieler(akt_spieler) \verdursten
               Case 1 : DrawText("Thirsty")
               Case 2 : DrawText("Very Thirsty")
               Case 3 : DrawText("Starving (Thirst)")
            EndSelect
         EndIf
      EndIf
      If spieler(akt_spieler) \fluch > 0
         y = y + 10
         Locate(x,y)
         FrontColor(150,150,150)  ; Grau
         If sprache = 0
            If spieler(akt_spieler) \fluch = #FLUCH_NAMENLOS
               DrawText("Der namelose Fluch")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_TIAMAT
               DrawText("Fluch der Tiamat")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_HEKATE
               DrawText("Fluch der Hekate")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_ARES
               DrawText("Fluch des Ares")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_PARALYSE
               DrawText("Fluch Paralyse")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_ARTEMIS
               DrawText("Fluch der Artemis")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_ACHILLES
               DrawText("Fluch des Achilles")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_BLINDHEIT
               DrawText("Fluch Blindheit")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_HEPHAISTOS
               DrawText("Fluch des Hephaistos")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_HADES
               DrawText("Fluch des Hades")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_SETH
               DrawText("Fluch des Seth")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_APOPHIS
               DrawText("Fluch des Apophis")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_DAGDA
               DrawText("Fluch des Dagda")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_NAIADEN
               DrawText("Fluch der Naiaden")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_OSIRIS
               DrawText("Fluch des Osiris")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_LEPRECHAUN
               DrawText("Fluch des Leprechaun")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_MARDUK
               DrawText("Fluch des Marduk")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_ASTARTE
               DrawText("Fluch der Astarte")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DES_POSEIDON
               DrawText("Fluch des Poseidon")
            EndIf
            If spieler(akt_spieler) \fluch = #FLUCH_DER_TANIS
               DrawText("Fluch der Tanis")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_ATHENE
               DrawText("Fluch der Athene")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_MORRIGU
               DrawText("Fluch der Morrigu")
            EndIf
            If spieler(1) \fluch = #FLUCH_CHICKEN
               DrawText("Huehnerfluch")
            EndIf
         Else
            If spieler(1) \fluch = #FLUCH_NAMENLOS
               DrawText("nameless curse")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_TIAMAT
               DrawText("curse of tiamat")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_HEKATE
               DrawText("curse of hekate")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_ARES
               DrawText("curse of ares")
            EndIf
            If spieler(1) \fluch = #FLUCH_PARALYSE
               DrawText("curse paralyse")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_ARTEMIS
               DrawText("curse of artemis")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_ACHILLES
               DrawText("curse of achilles")
            EndIf
            If spieler(1) \fluch = #FLUCH_BLINDHEIT
               DrawText("curse blindness")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_HEPHAISTOS
               DrawText("curse of hephaistos")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_HADES
               DrawText("curse of hades")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_SETH
               DrawText("curse of seth")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_APOPHIS
               DrawText("curse of apophis")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_DAGDA
               DrawText("curse of dagda")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_NAIADEN
               DrawText("curse of naiaden")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_OSIRIS
               DrawText("curse of osiris")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_LEPRECHAUN
               DrawText("curse of leprechaun")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_MARDUK
               DrawText("curse of marduk")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_ASTARTE
               DrawText("curse of astarte")
            EndIf
            If spieler(1) \fluch = #FLUCH_DES_POSEIDON
               DrawText("curse of poseidon")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_TANIS
               DrawText("curse of tanis")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_ATHENE
               DrawText("curse of athene")
            EndIf
            If spieler(1) \fluch = #FLUCH_DER_MORRIGU
               DrawText("curse of morrigu")
            EndIf
            If spieler(1) \fluch = #FLUCH_CHICKEN
               DrawText("chickencurse")
            EndIf
         EndIf
      EndIf

   StopDrawing()

EndProcedure
; ExecutableFormat=
; EOF
